# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define namedversion 1.5rc3

Summary:        Java Source Code Formatter Beautifier Pretty Printer
Name:           jalopy
Version:        1.5
Release:        0.rc3.2%{?dist}
Epoch:          0
Group:          Software Development/Quality Assurance
License:        BSD
URL:            http://jalopy.sourceforge.net/
BuildArch:      noarch
Source0:        http://download.sourceforge.net/jalopy/jalopy-1.5rc3-src.tar.gz
#Source1:        http://download.sourceforge.net/jalopy/jalopy-ant-0.1-1.5rc3-src.tar.gz
#Source2:        http://download.sourceforge.net/jalopy/jalopy-console-0.1-1.5rc3-src.tar.gz
#Source3:        http://download.sourceforge.net/jalopy/jalopy-jedit-0.2-1.5rc3-src.tar.gz

Source1:        %{name}.jalopy.script
Source2:        %{name}-settings.sh
Source3:        http://repo1.maven.org/maven2/jalopy/jalopy/1.5rc3/jalopy-1.5rc3.pom
# Converted from main/src/resources/Preferences16.gif
Source4:        %{name}-settings.png
Source5:        pom-maven2jpp-depcat.xsl
Source6:        pom-maven2jpp-newdepmap.xsl
Source7:        pom-maven2jpp-mapdeps.xsl
Source8:        jalopy-1.5-jpp-depmap.xml

Patch0:         jalopy-1.5-project_xml.patch
Patch1:         jalopy-1.5-project_properties.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  antlr
BuildRequires:  maven >= 0:1.1
BuildRequires:  maven-plugins-base
BuildRequires:  maven-plugin-antlr
BuildRequires:  maven-plugin-changes
BuildRequires:  maven-plugin-license
BuildRequires:  maven-plugin-test
BuildRequires:  maven-plugin-xdoc
BuildRequires:  log4j
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:  docbook-xsl-java-saxon
# This one's named the same on many distros and is located in same place...
#BuildRequires:  docbook-style-xsl
#BuildRequires:  /usr/bin/perl
Requires:       java >= 0:1.5.0
Requires:       log4j
Requires(post):    jpackage-utils >= 0:1.7.3
Requires(postun):  jpackage-utils >= 0:1.7.3

%description
Jalopy is a source code formatter for the Sun Java programming
language. It layouts any valid Java source code according to some
widely configurable rules; to meet a certain coding style without
putting a formatting burden on individual developers.
With Jalopy you will be able to transform any foreign coding style to
your own preferences, without any browbeating or bloodletting.

%package        manual
Group:          Software Development/Quality Assurance
Summary:        Manual for %{name}

%description    manual
Documentation for %{name}.

%package        javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description    javadoc
Javadoc for %{name}.


%prep
%setup -q -n %{name}-%{namedversion}
%patch0 -b .sav0
%patch1 -b .sav1
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
# Fix path to DocBook XSL's.  For some reason, a "-DDIR.DOCBOOK.XSL" does
# not seem to work.
#perl -pi -e \
#  's|^(DIR\.DOCBOOK\.XSL\s*=).*|$1 %{_datadir}/sgml/docbook/xsl-stylesheets|' \
#  build/build.properties


%build

export DEPCAT=$(pwd)/jalopy-1.5-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE5} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE6} > jalopy-1.5-depmap.new.xml

for p in $(find . -name "*project.xml"); do
    pushd $(dirname $p)
    b=$(basename $p)
    cp ${b} ${b}.orig
    /usr/bin/saxon -o ${b} ${b}.orig %{SOURCE7} map=%{SOURCE8}
    popd
done

cd jalopy

export MAVEN_HOME_LOCAL=$(pwd)/.maven
maven -e \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar javadoc xdoc:transform


%install
rm -rf $RPM_BUILD_ROOT

# jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 temp/%{name}/%{name}-%{namedversion}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

%add_to_maven_depmap jalopy %{name} %{namedversion} JPP %{name}

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE3} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# scripts
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/%{name}-settings

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr temp/%{name}/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# docs 
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
rm -rf temp/%{name}/docs/apidocs
cp -pr temp/%{name}/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/%{name}
%attr(0755,root,root) %{_bindir}/%{name}-settings
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_mavendepmapfragdir}/*
%{_datadir}/maven2/poms/*

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}


%changelog
* Mon Apr 27 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.5-0.rc3.2.jpp5
- Minor fixes

* Thu Apr 02 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.5-0.rc3.1.jpp5
- 1.5
- subpackages dropped

* Mon Jun 19 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.b11.1jpp
- Adapt to eclipse-3.1.* and JPP-1.7
- Upgrade to 1.0-b11
- Rename ant-jalopy to jalopy-ant, eclipse-jalopy to jalopy-eclipse
  with corresponding Provides/Obsoletes

* Thu Feb 16 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.b10.8jpp
- Adapt to eclipse-3.0.2 and JPP-1.7

* Sat Nov 13 2004 Ville Skyttä <scop at jpackage.org> - 0:1.0-0.b10.7jpp
- BuildRequire ant-trax.

* Sat Sep 25 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.b10.6jpp
- Patch to adapt to jdom-1.0 final
- Require eclipse-* >= 2.1.3 because of plugin dir location

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0-0.b10.5jpp
- Rebuild with ant-1.6.2

* Fri Nov 14 2003 Ville Skyttä <scop at jpackage.org> - 0:1.0-0.b10.4jpp
- Eclipse plugins are now in %%{_datadir}/eclipse.
- Clean up non-versioned javadoc dir symlinking.
- Rename jalopy-preferences to jalopy-settings.
- Add freedesktop.org menu entry for jalopy-settings.
- Fix manual XSL.
- Save .spec in UTF-8, some small cleanups.

* Mon Jun 16 2003 Ville Skyttä <scop at jpackage.org> - 0:1.0-0.b10.3jpp
- Get rid of Class-Paths in manifests, add missing oro.jar to
  base jars in %%{_bindir}/jalopy.

* Sat Mar  1 2003 Ville Skyttä <scop at jpackage.org> - 0:1.0-0.b10.2jpp
- Update for JPackage 1.5.
- Build Eclipse plugin.  (jEdit plugin builds, but doesn't work, deferred)
- Rename ant plugin to ant-jalopy.
- Force use of Saxon when building docs, Xalan from J2SE 1.4 is too buggy.

* Fri Nov 15 2002 Ville Skyttä <scop at jpackage.org> - 1.0-0.b10.1jpp
- Update to 1.0b10.

* Wed Nov 13 2002 Ville Skyttä <scop at jpackage.org> - 1.0-0.b9.1jpp
- Update to 1.0b9.
- Fix Group tags of manual and javadoc.
- Update preferences shell script main class.

* Sat Oct 12 2002 Ville Skyttä <scop at jpackage.org> - 1.0-0.b8.1jpp
- First JPackage release.
